<template>
    <v-app id="inspire">
        <v-navigation-drawer
                color="#3d5a88"
                :expand-on-hover="true"
                :mini-variant="true"
                :right="false"
                dark
                app
        >
            <v-list
                    nav
                    class="py-0"
            >
                <v-list-item two-line :class="true && 'px-0'">
                    <v-list-item-avatar>
                        <img src="./assets/logo.png">
                    </v-list-item-avatar>

                    <v-list-item-content>
                        <v-list-item-title>File processor</v-list-item-title>
                        <v-list-item-subtitle>converter</v-list-item-subtitle>
                    </v-list-item-content>
                </v-list-item>

                <v-divider></v-divider>

                <router-link :to="item.to"
                             v-for="item in computedItems"
                             :key="item.title"
                >
                    <v-list-item
                            link
                            active-class="linkActive"
                    >

                        <v-list-item-icon>
                            <v-icon>{{ item.icon }}</v-icon>
                        </v-list-item-icon>

                        <v-list-item-content>
                            <v-list-item-title>{{ item.title }}</v-list-item-title>
                        </v-list-item-content>

                    </v-list-item>
                </router-link>

            </v-list>
        </v-navigation-drawer>

        <v-app-bar
                app
                color="#3d5a88"
                dark
        >
            <v-toolbar-title>File processor</v-toolbar-title>
            <v-spacer></v-spacer>

                <v-toolbar-title v-if="isLoggedIn" style="margin-right: 1em">Hello, {{loggedUser}} </v-toolbar-title>
                <v-btn small color="red accent-2" v-on:click="logoutClicked" v-if="isLoggedIn">
                    Logout
                    <v-icon style="padding-left: 10px">fas fa-sign-out-alt</v-icon>
                </v-btn>
        </v-app-bar>

        <!-- The video -->
        <video autoplay muted loop id="myVideo">
            <source src="./assets/technology_background.mp4" type="video/mp4">
        </video>
        <v-content class="bac content">
            <v-container
                    fluid
            >
                <v-row>
                    <v-col style="opacity: 0.9">
                        <transition name="slide-fade" mode="out-in" appear>
                            <router-view></router-view>
                        </transition>
                    </v-col>
                </v-row>
            </v-container>
        </v-content>
    </v-app>
</template>

<style>
    .back {
        background-image: url(https://gfycat.com/abletastycirriped);
        background-size: cover;
    }



    #inspire {
        background: none;
    }

    #myVideo {
        position: fixed;
        right: 0;
        bottom: 0;
        min-width: 100%;
        min-height: 100%;
    }

    /* Add some content at the bottom of the video/page */
    .content {
        width: 100%;
    }

    .slide-fade-enter-active {
        transition: all .22s ease;
    }

    .slide-fade-leave-active {
        transition: all .22s cubic-bezier(1.0, 0.5, 0.8, 1.0);
    }

    .slide-fade-enter, .slide-fade-leave-to
        /* .slide-fade-leave-active below version 2.1.8 */
    {
        transform: translateX(200px);
        opacity: 0;
    }
</style>

<script>
    import FileManager from "./components/FileManager/FileManager";
    import {getLoggedUser, isLoggedIn, logout} from "./util/auth";

    export default {
        name: 'App',
        components: {FileManager},
        props: {
            source: String,
        },
        data() {
            return {
                items: [
                    {title: 'Dashboard', icon: 'mdi-view-dashboard', to:'/home', admin: false},
                    {title: 'Statistics', icon: 'fas fa-chart-area', to:'/stats', admin: true},
                    {title: 'MyFiles', icon: 'fas fa-list', to:'/my-files', admin: false},
                    {title: 'Users', icon: 'fas fa-user', to:'/users', admin: true},
                ],
                color: 'primary'
            }
        },
        methods:{
            logoutClicked: function(){
                logout()
            }
        },
        created() {
            if(getLoggedUser().user.user.username !== 'admin'){
                this.items = this.items.filter(path => !path.admin)
            }
        },
        computed: {
            isLoggedIn () {
                return this.$store.state.isLoggedIn
            },
            loggedUser () {

                let message = this.$store.state.user;
                let user = JSON.parse(JSON.stringify(message));
                return user.user.user.firstName
            },
            computedItems(){
                let message = this.$store.state.user;
                let user = JSON.parse(JSON.stringify(message));
                if(this.$store.state.isLoggedIn && user.user.user.username !== 'admin'){
                    return this.items.filter(path => !path.admin)
                } else if(!this.$store.state.isLoggedIn){
                    return []
                } else
                return this.items
            }
        }
    }
</script>